program LabClient_pas;
uses Windows, SysUtils, WinSock, Robot;
type 
  StrT = AnsiString;
  StrArr = array of string;

type TMySock = class
public
  constructor Create;
  destructor Destroy; override;
  function Connect(HostName: string; Port: integer): boolean;
  function ReadLine: StrT;
  function ReadLineV: StrArr;
  procedure WriteLine(S: StrT);
private
  Sock: WinSock.TSocket;
  Buffer: StrT;
end; {TMySock}

constructor TMySock.Create;
begin
  Sock := WinSock.TSocket(-1);
  Buffer := '';
end; {TMySock.Create}

destructor TMySock.Destroy;
begin
  WinSock.CloseSocket(Sock);
end; {TMySock.Destroy}

function TMySock.Connect(HostName: string; Port: integer): boolean;
var  
  SAddr: TSockAddrIn; he: PHostEnt;
  wVersionRequested: word;
  wsaData: TWSAData;
begin
  wVersionRequested := MAKEWORD(2, 2);
  WinSock.WSAStartup(wVersionRequested, wsaData);
  HostName := HostName + Chr(0);
  he := WinSock.GetHostByName(@(HostName[1]));
  Connect := false;
  if he = nil then exit;
  
  SAddr.sin_family := AF_INET;
  SAddr.sin_port := WinSock.htons(u_short(Port));
  SAddr.sin_addr.s_addr := PInAddr(he^.h_addr^)^.s_addr;
  
  Sock := WinSock.Socket(PF_INET, SOCK_STREAM, 0);
  if Sock = WinSock.TSocket(-1) then exit;
  if WinSock.Connect(Sock, PSockAddr(@SAddr), SizeOf(Saddr)) <> 0 then exit;
  
  Connect := true;
  WriteLn('Connected.');
end; {Connect}

function TMySock.ReadLine: StrT;
var i: integer; q: StrT; Tmp: packed array [0..129] of char;
begin
  while true do begin
    {WriteLn('ReadLine loop');}
    i := 1; while i <= Length(Buffer) do if Ord(Buffer[i]) = 10 then break else i := i + 1;
    if i <= Length(Buffer) then begin
      q := Copy(Buffer, 1, i - 1);
      Buffer := Copy(Buffer, i + 1, Length(Buffer) - i);
      q := Trim(q);
      {WriteLn('<< ', q);}
      ReadLine := q;
      exit;
    end; {if}
    {WriteLn('Calling recv.');}
    i := WinSock.recv(Sock, @(Tmp[0]), 128, 0);
    {WriteLn('recv ', i);}
    if i < 0 then raise Exception.Create('Napaka pri komunikaciji s streznikom');
    if i = 0 then raise Exception.Create('Streznik je zaprl povezavo');
    Tmp[i] := #0;
    Buffer := Buffer + Tmp;
    {Write('Buffer now "', Buffer, '" ');
    for i := 1 to Length(Buffer) do Write(Ord(Buffer[i]), ' ');}
  end; {while}
end; {ReadLine}

function TMySock.ReadLineV: StrArr;
var i, j, Used, Cap: integer; Line: StrT;
begin
  Used := 0; Cap := 1; 
  SetLength(Result, Cap);
  i := 1; Line := ReadLine;
  while i <= Length(Line) do begin
    j := i; while j <= Length(Line) do if Line[j] = ' ' then break else j := j + 1;
    if Used = Cap then begin Cap := 2 * Cap; SetLength(Result, Cap) end;
    Result[Used] := Copy(Line, i, j - i); Used := Used + 1;
    i := j + 1;
  end; {while}
  SetLength(Result, Used);
end; {ReadLineV}

procedure TMySock.WriteLine(S: StrT);
begin
  {WriteLn('>> ', S);}
  S := S + Chr(13) + Chr(10);
  WinSock.Send(Sock, @(S[1]), Length(S), 0);
end; {WriteLine}

procedure Connect(HostName: string; PortNo: integer; var Sock: TMySock);
var Server, Success: StrT;
begin
  Sock := TMySock.Create;
  if not Sock.Connect(HostName, PortNo) then raise Exception.Create('Povezava s streznikom neuspesna');
  Server := Sock.ReadLine;
  WriteLn(Server);
  Sock.WriteLine('AVE ' + TRobot.Ime);
  Success := Sock.ReadLine;
  if Success <> 'PRIJAVA USPESNA' then raise Exception.Create('Prijava na streznik neuspesna: ' + Success);
end; {Connect}

procedure EventLoop(Sock: TMySock);
var 
  CmdA: StrArr; Robot: TRobot; i, nVidenih: integer;
  Razlog: TZakajKonec; Opis: string;
  NosimBreme: boolean; KajVidim: TVidenaPolja; vp: TVidenoPolje; S: string; Premik: TPremik;
begin
  while true do begin
    CmdA := Sock.ReadLineV;
    if CmdA[0] = 'ADIJO' then exit;
    if CmdA[0] = 'KONEC_IGRE' then continue;
    if CmdA[0] <> 'ZBUDI_SE' then raise Exception.Create('Napaka pri komunikaciji s streznikom');
    
    Robot := TRobot.Create;
    Robot.ZbudiSe(StrToInt(CmdA[1]), StrToInt(CmdA[2]), StrToInt(CmdA[3]));
    Sock.WriteLine('BUDEN');
    
    while true do begin
      CmdA := Sock.ReadLineV;
      if CmdA[0] = 'ADIJO' then exit;
      if CmdA[0] = 'KONEC_IGRE' then begin
        if CmdA[1] = 'ZMAGA' then Razlog := zkZmaga
        else if CmdA[1] = 'NAPAKA' then Razlog := zkNapaka
        else Razlog := zkDrugo;
        Opis := ''; for i := 2 to High(CmdA) do begin 
          if i > 2 then Opis := Opis + ' ';
          Opis := Opis + CmdA[i];
        end; {for i}
        Robot.KonecIgre(Razlog, Opis);
        Robot.Free;
        break;
      end else if CmdA[0] = 'QV' then begin
        NosimBreme := (CmdA[1] = 'B');
        nVidenih := StrToInt(CmdA[2]);
        SetLength(KajVidim, nVidenih);
        for i := 0 to nVidenih - 1 do begin
          vp.RowsAhead := StrToInt(CmdA[3 + 3 * i]);
          vp.Column := StrToInt(CmdA[4 + 3 * i]);
          S := CmdA[5 + 3 * i];
          if S = '.' then vp.Tip := tpProsto
          else if S = 'x' then vp.Tip := tpIzhod
          else if S = '#' then vp.Tip := tpKockaAliZid
          else if S = 'Z' then vp.Tip := tpZunanjiZid
          else raise Exception.Create('Napaka pri komunikaciji s streznikom: neznan tip polja ''' + S + '''.');
          KajVidim[i] := vp;
        end; {for i}
        Premik := Robot.KamGres(NosimBreme, KajVidim);
        case Premik of
          prNaprej: S := 'NAPREJ';
          prLevo: S := 'LEVO';
          prDesno: S := 'DESNO';
          prPoberi: S := 'POBERI';
          prSpusti: S := 'SPUSTI';
          prObrni: S := 'UTURN';
          else S := 'napaka';
        end; {case}
        Sock.WriteLine('QVR ' + S);
      end else
        raise Exception.Create('Napaka pri komunikaciji s streznikom: neznan tip sporocila ''' + Cmda[0] + '''.');
    end; {while}
  end; {while}
end; {EventLoop}

var HostName: string; PortNo: integer; Sock: TMySock;
begin {LabClient_pas}
  try
    if ParamCount < 1 then HostName := 'localhost'
    else HostName := ParamStr(1);
    if ParamCount < 2 then PortNo := 1176
    else PortNo := StrToInt(ParamStr(2));
  
    Connect(HostName, PortNo, Sock);
    EventLoop(Sock);
    {WriteLn(HostName, ':', PortNo);
    raise Exception.Create('hopsasa');}
  except on e: Exception do
    WriteLn(e.Message);
  end;
end. {LabClient_pas}