unit Robot;

interface

type 
  TZakajKonec = (
    zkNapaka = 0, 
    zkZmaga = 1, 
    zkDrugo = 2
  );
  
  TPremik = (
    prNaprej = 1, 
    prLevo = 2, 
    prDesno = 3, 
    prObrni = 4, { obrat za 180 stopinj }
    prPoberi = 5, 
    prSpusti = 6
  );
  
  TTipPolja = (
    tpProsto = 1,
    tpIzhod = 2,
    tpKockaAliZid = 3,
    tpZunanjiZid = 4
  );

  TVidenoPolje = record
    RowsAhead: integer; { koliko vrstic pred nasim robotom je to polje: 1..vidljivost }
    Column: integer; { koliko stolpcev levo ali desno od nasega robota je to polje;
		       -vidljivost <= column <= vidljivost (negativna stevila so levo) }
    Tip: TTipPolja;
  end; {TVidenoPolje}
  
  TVidenaPolja = array of TVidenoPolje;

  TRobot = class
  public
    class function Ime: string;
    procedure ZbudiSe(Sirina, Visina, Vidljivost: integer);
    function KamGres(NosimBreme: boolean; KajVidim: TVidenaPolja): TPremik;
    procedure KonecIgre(Razlog: TZakajKonec; Opis: string);
  end; {TRobot}

implementation

class function TRobot.Ime: string;
begin
  { Tu vpisi ime svojega robota. }
  Ime := 'PascalRobot';
end; {Ime}

procedure TRobot.ZbudiSe(Sirina, Visina, Vidljivost: integer);
begin
  { Tu dodaj svojo implementacijo. }
  WriteLn('Igram na mrezi ', Sirina, ' x ', Visina, ', vidljivost = ', Vidljivost);
end; {ZbudiSe}

function TRobot.KamGres(NosimBreme: boolean; KajVidim: TVidenaPolja): TPremik;
var 
  Moznosti: array [0..10] of TPremik; nMoznosti: integer;
  i: integer;
begin
  { Tu dodaj svojo implementacijo. 
    Spodnji primer pogleda, katere poteze so v trenutnem stanju mozne, 
    in nakljucno izbere eno od njih. }
  { - V vsakem primeru se lahko obracamo na mestu. }
  Moznosti[0] := prLevo;
  Moznosti[1] := prDesno;
  Moznosti[2] := prObrni; nMoznosti := 3;
  
  { - Ostali premiki so odvisni od tega, kaj je na polju pred nami. }
  for i := Low(KajVidim) to High(KajVidim) do begin
    if (KajVidim[i].RowsAhead <> 1) or (KajVidim[i].Column <> 0) then continue;
    { - Ce je polje pred nami prosto, lahko stopimo nanj; 
        ce nosimo kocko, jo lahko tudi odlozimo. }
    if KajVidim[i].Tip in [tpProsto, tpIzhod] then begin
      Moznosti[nMoznosti] := prNaprej; nMoznosti := nMoznosti + 1;
      if NosimBreme and (KajVidim[i].Tip = tpProsto) then begin
        Moznosti[nMoznosti] := prSpusti; nMoznosti := nMoznosti + 1;
      end; {if}
    end 
    { - Ce pa polje pred nami ni prosto, lahko poskusimo kocko na njem pobrati. }
    else if (KajVidim[i].Tip = tpKockaAliZid) and not NosimBreme then begin
      Moznosti[nMoznosti] := prPoberi; nMoznosti := nMoznosti + 1;
      Moznosti[nMoznosti] := prPoberi; nMoznosti := nMoznosti + 1;
      Moznosti[nMoznosti] := prPoberi; nMoznosti := nMoznosti + 1;
    end; {if}
    break;
  end; {if}
  
  KamGres := Moznosti[Random(nMoznosti)];
end; {KamGres}

procedure TRobot.KonecIgre(Razlog: TZakajKonec; Opis: string);
begin
  { Tu dodaj svojo implementacijo. }
  WriteLn('Konec igre');
end; {KonecIgre}

end. {Robot}
